diff -uNrd ircd-hybrid-6.3.1.dist/include/client.h ircd-hybrid-6.3.1/include/client.h
--- ircd-hybrid-6.3.1.dist/include/client.h	Sun Feb 17 00:58:09 2002
+++ ircd-hybrid-6.3.1/include/client.h	Tue Apr 29 22:27:23 2003
@@ -51,8 +51,6 @@
 #define HOSTIPLEN       16      /* Length of dotted quad form of IP        */
                                 /* - Dianora                               */
 #define PASSWDLEN       20
-#define IDLEN           12      /* this is the maximum length, not the actual
-                                   generated length; DO NOT CHANGE! */
 #define CLIENT_BUFSIZE 512      /* must be at least 512 bytes */
 
 /*
@@ -79,7 +77,6 @@
   time_t         last;
   int            refcnt;        /* Number of times this block is referenced */
   int            joined;        /* number of channels joined */
-  char           id[IDLEN + 1]; /* for future use *hint* */
   const char*    server;        /* pointer to scached server name */
   /*
   ** In a perfect world the 'server' name
@@ -103,6 +100,7 @@
   struct Client*   servers;     /* Servers on this server */
   struct Client*   users;       /* Users on this server */
   int		   tsversion;   /* ts version sent in SVINFO */
+  unsigned int usercnt;
 };
 
 struct Client
@@ -238,6 +236,9 @@
   time_t            last_nick_change;
   int               number_of_nick_changes;
 #endif
+#ifdef ANTI_IP_SPOOF
+  unsigned int random_ping;
+#endif
   time_t            last_knock; /* don't allow knock to flood */
   /*
    * client->sockhost contains the ip address gotten from the socket as a
@@ -337,9 +338,13 @@
 #define FLAGS_INVISIBLE    0x0400 /* makes user invisible */
 #define FLAGS_BOTS         0x0800 /* shows bots */
 #define FLAGS_EXTERNAL     0x1000 /* show servers introduced */
+#define FLAGS_UNAUTH       0x2000 /* show unauth messages */
 /* user information flags, only settable by remote mode or local oper */
 #define FLAGS_OPER         0x4000 /* Operator */
 #define FLAGS_LOCOP        0x8000 /* Local operator -- SRB */
+#define FLAGS_ADMIN        0x10000 /* Server Administrator */
+#define FLAGS_LOCOPS       0x20000 /* local wallops */
+#define FLAGS_JUPE         0x40000 /* client joining juped channel */
 
 /* *sigh* overflow flags */
 #define FLAGS2_RESTRICTED   0x0001      /* restricted client */
@@ -349,6 +354,10 @@
 #define FLAGS2_F_LINED      0x0010      /* client is graced with F line */
 #define FLAGS2_EXEMPTGLINE  0x2000      /* client can't be G-lined */
 
+#ifdef ANTI_IP_SPOOF
+# define FLAGS2_GOT_ANTI_SPOOF_PING    0x800000
+#endif
+
 /* oper priv flags */
 #define FLAGS2_OPER_GLOBAL_KILL 0x0020  /* oper can global kill */
 #define FLAGS2_OPER_REMOTE      0x0040  /* oper can do squits/connects */
@@ -358,6 +367,7 @@
 #define FLAGS2_OPER_K           0x0400  /* oper can kill/kline */
 #define FLAGS2_OPER_DIE         0x0800  /* oper can die */
 #define FLAGS2_OPER_REHASH      0x1000  /* oper can rehash */
+#define FLAGS2_OPER_ADMIN       0x01000000 /* oper is an admin */
 #define FLAGS2_OPER_FLAGS       (FLAGS2_OPER_GLOBAL_KILL | \
                                  FLAGS2_OPER_REMOTE | \
                                  FLAGS2_OPER_UNKLINE | \
@@ -365,7 +375,9 @@
                                  FLAGS2_OPER_N | \
                                  FLAGS2_OPER_K | \
                                  FLAGS2_OPER_DIE | \
-                                 FLAGS2_OPER_REHASH)
+                                 FLAGS2_OPER_REHASH | \
+                                 FLAGS2_OPER_ADMIN)
+
 /* ZIP_LINKS */
 
 #define FLAGS2_ZIP           0x4000  /* (server) link is zipped */
@@ -383,11 +395,12 @@
 #define FLAGS2_SENDQ_POP  0x400000  /* sendq exceeded (during list) */
 
 
-#define SEND_UMODES  (FLAGS_INVISIBLE | FLAGS_OPER | FLAGS_WALLOP)
+#define SEND_UMODES  (FLAGS_INVISIBLE | FLAGS_OPER | FLAGS_WALLOP | FLAGS_ADMIN)
 #define ALL_UMODES   (SEND_UMODES | FLAGS_SERVNOTICE | FLAGS_CCONN | \
                       FLAGS_REJ | FLAGS_SKILL | FLAGS_FULL | FLAGS_SPY | \
                       FLAGS_NCHANGE | FLAGS_OPERWALL | FLAGS_DEBUG | \
-                      FLAGS_BOTS | FLAGS_EXTERNAL | FLAGS_LOCOP )
+                      FLAGS_BOTS | FLAGS_EXTERNAL | FLAGS_LOCOP | \
+                      FLAGS_UNAUTH | FLAGS_LOCOPS | FLAGS_JUPE )
 
 #ifndef OPER_UMODES
 #define OPER_UMODES  (FLAGS_OPER | FLAGS_WALLOP | FLAGS_SERVNOTICE | \
@@ -434,6 +447,8 @@
 #define SendServNotice(x)       (((x)->umodes & FLAGS_SERVNOTICE) && IsAnOper(x))
 #define SendOperwall(x)         ((x)->umodes & FLAGS_OPERWALL)
 #define SendCConnNotice(x)      ((x)->umodes & FLAGS_CCONN)
+#define SendUnauthNotice(x)     ((x)->umodes & FLAGS_UNAUTH)
+#define SendJupeNotice(x)       ((x)->umodes & FLAGS_JUPE)
 #define SendRejNotice(x)        ((x)->umodes & FLAGS_REJ)
 #define SendSkillNotice(x)      ((x)->umodes & FLAGS_SKILL)
 #define SendFullNotice(x)       ((x)->umodes & FLAGS_FULL)
@@ -441,6 +456,7 @@
 #define SendDebugNotice(x)      ((x)->umodes & FLAGS_DEBUG)
 #define SendNickChange(x)       ((x)->umodes & FLAGS_NCHANGE)
 #define SetWallops(x)           ((x)->umodes |= FLAGS_WALLOP)
+#define SendLocops(x)           (((x)->umodes & FLAGS_LOCOPS) && IsAnOper(x))
 
 
 #ifdef REJECT_HOLD
@@ -503,6 +519,8 @@
 #define IsOperDie(x)            ((x)->flags2 & FLAGS2_OPER_DIE)
 #define SetOperRehash(x)        ((x)->flags2 |= FLAGS2_OPER_REHASH)
 #define IsOperRehash(x)         ((x)->flags2 & FLAGS2_OPER_REHASH)
+#define SetOperAdmin(x)         ((x)->flags2 |= FLAGS2_OPER_ADMIN)
+#define IsSetOperAdmin(x)       ((x)->flags2 & FLAGS2_OPER_ADMIN)
 #define CBurst(x)               ((x)->flags2 & FLAGS2_CBURST)
 
 /*
diff -uNrd ircd-hybrid-6.3.1.dist/include/config.h ircd-hybrid-6.3.1/include/config.h
--- ircd-hybrid-6.3.1.dist/include/config.h	Sun Feb 17 00:58:09 2002
+++ ircd-hybrid-6.3.1/include/config.h	Fri May  2 11:33:29 2003
@@ -111,6 +111,224 @@
 #define HPATH   "opers.txt"
 #define OPATH   "opers.motd"
 
+/* +fr patches - Hwy
+ * Each is optional...
+ */
+
+/* SAVE_MAXCLIENT - store the max local and global client connections
+ * into the file specified by MXPATH at the interval specified by
+ * SAVE_TIME
+ * Credits:  Hwy, idea from bahamut
+ */
+#define SAVE_MAXCLIENT
+#ifdef SAVE_MAXCLIENT
+# define MXPATH "ircd.max"
+# define SAVE_TIME 3600
+#endif
+
+/*
+ * XLINE_COMMAND - Enable a command to dynamically add an X: line
+ * Credits:  Hwy
+ */
+#undef XLINE_COMMAND
+
+/* Don't touch these */
+#define XLINE_WARN 0
+#define XLINE_REJECT 1
+#define XLINE_SILENT 2
+
+/* Set the default type of XLINE to be created, can be changed with
+ * /quote SET XLINETYPE [WARN|REJECT|SILENT].
+ */
+#define DEFAULT_XLINETYPE XLINE_WARN
+
+/*
+ * CRYPT_AUTH_PASSWORD - I: line passwords need to be crypted with
+ * mkpasswd to be valid
+ * Credits:  Hwy/larne
+ */
+#undef CRYPT_AUTH_PASSWORD
+
+/*
+ * GECOS_CLICONNECT - show the gecos when a user connects in the +c notice
+ *
+ * NOTE:  This MAY break oper scripts that parse the +c notice!
+ * Credits:  Hwy, backported from -7
+ */
+#define GECOS_CLICONNECT
+
+/* ANTI_IP_SPOOF - protects against TCP sequence guessing attacks
+ * Define this if you want the server to send a random ping at USER or NICK
+ * to defeat IP sequence spoofers. Note, this will stop _some_ very few
+ * clients from using the server. MIRC/IRCII clients are fine with this though
+ *
+ * IP sequence spoofing is obsolete...but for the time being...you can
+ * use this same code to defeat certain dumb drones and certain types of
+ * dumb bots.
+ *
+ * Credits:  JailBird, taken from FEFr5 with some fixes by Hwy
+ */
+#undef ANTI_IP_SPOOF
+
+/* REMOTE_WHOIS_NOTICE - Spy on users, even if they are remote */
+#undef REMOTE_WHOIS_NOTICE
+
+/* POST_REGISTER - Reject a client that issues the POST, GET, or PUT
+ * commands during registration.  This is often done by HTTP proxies.
+ * Credits:  Hwy, backported from -7
+ */
+#define POST_REGISTER
+
+/* CHECK_CLONE - Clonebot Protection.  This feature blocks connections if more
+ * than CHECK_CLONE_LIMIT clients connect from the same host to ANY server on
+ * the network within CHECK_CLONE_PERIOD seconds.  The feature is enabled
+ * CHECK_CLONE_DELAY seconds after the server is started.
+ *
+ * CHECK_CLONE_LIMIT and CHECK_CLONE_PERIOD are the defaults.  They can be
+ * changed with /quote SET.  CHECK_CLONE_DELAY is only used upon server
+ * boot, so it's not a SET'table option.
+ *
+ * Credits:  SeKs, ripped from FEFr5
+ */
+#define CHECK_CLONE
+#define CHECK_CLONE_LIMIT     5 /* recommended value 2   */
+#define CHECK_CLONE_PERIOD   30 /* recommended value 20  */
+#define CHECK_CLONE_DELAY    90 /* 90 secs should be ok */
+
+/* PART_MESSAGES - PART can include a comment, IRCnet and Dalnet style
+ * The message will get ignored by servers that do not understand...
+ * H6+tXi, H6+ins, H7, H6.3+fr all support this.
+ * Credits:  toot
+ */
+#define PART_MESSAGES
+
+/* SILENCE_ON_BAN - Banned users cannot speak in a channel, IRCnet style
+ * Credits:  toot
+ */
+#define SILENCE_ON_BAN
+
+/* TOPIC_UH - IRCnet style nick!user@host topic info.
+ * Credits:  toot, modified by Hwy
+ */
+#define TOPIC_UH
+
+/* FLAGS_COMMAND - Enable the csircd like FLAGS command
+ * Credits:  Hwy (backported from H7 contrib/m_flags.c)
+ */
+#define FLAGS_COMMAND
+
+/* FLAGS_ANNOUNCE - Announce the client's current and missing flags
+ * when they register, csircd like
+ */
+#define FLAGS_ANNOUNCE
+
+/* CLIENT_EXIT - Mark local client /quit's with "Quit: "
+ * Credits:  larne (stolen from +ins)
+ */
+#define CLIENT_EXIT
+
+/* STATS_IGNORED_NOTICE - Send a 419 numeric to a user who has a STATS
+ * request ignored
+ * Credits:  Idea by someone from the EFnet.org forum, code by Hwy
+ */
+#define STATS_IGNORED_NOTICE
+
+/* WHOIS_TRYAGAIN - When a remote WHOIS request is ignored, send a "Load
+ * too high" numeric to let them know it was ignored.  Stock Hybrid will
+ * not send this notice, just silently ignore it.  Sending a notice CAN
+ * increase sendQ.
+ */
+#define WHOIS_TRYAGAIN
+
+/* NEG_PORT - Allow a negative port number to be used in a C: line to
+ * specify a port number, but disable autoconnect on that C: line
+ * Idea from jv's +hemp patch for IRCnet
+ *
+ * Enabling this option will also hide the "autoconnect is disabled" warnings
+ * that will normally be sent every connection frequency minutes
+ */
+#define NEG_PORT
+
+/* DEFAULT_MAXTKTIME - Use this to set the default maximum TKLINE time
+ * in minutes.  This option can be changed at runtime using /quote SET
+ * MAXTKTIME minutes
+ */
+#define DEFAULT_MAXTKTIME (60*24)
+
+/* DEOPER_NOTICE - Use this to see when opers remove their operator status
+ * or quit.  - Spying... Hwy
+ */
+#undef DEOPER_NOTICE
+
+/* JUPE_BYPASS - Use this to allow opers to join and speak in juped (+j)
+ * channels, useful for under attack channels, drone channels, and oper
+ * channels
+ */
+#define JUPE_BYPASS
+
+/* TKLINE_EXPIRE_NOTICE - Use this to enable or disable the stock Hybrid
+ * temporary kline expiration notice
+ */
+#define TKLINE_EXPIRE_NOTICE
+
+/* TDLINE_EXPIRE_NOTICE - Use this to enable or disable fl_'s temporary
+ * dline expiration notice
+ */
+#define TDLINE_EXPIRE_NOTICE
+
+/* PROPAGATE_AWAY - Propogate AWAY messages to (and from) other servers.
+ * This allows users to see you marked as AWAY on distant servers, without
+ * resorting to using remote WHOIS.  This is standard in Hybrid 7 and will
+ * be standard in the next csircd version, so it should be available to
+ * Hybrid 6 users as well.
+ */
+#define PROPAGATE_AWAY
+
+/* BURST_AWAY - If AWAY messages are propagated, then burst them to a
+ * connecting server as well.  Hybrid 7 does NOT do this.
+ *
+ * NOTE:  This will increase your burst size.
+ */
+#define BURST_AWAY
+
+/* REVERT_USERHOST - Revert USERHOST to the original behavior, making
+ * USERHOST on yourself return the hostname (even if it is spoofed) rather
+ * than your real IP.  This will break mIRC's SERVER method of finding your
+ * IP when a user runs behind a NAT, but will fix the possible problems
+ * with client's userlists (adding protection for yourself)
+ */
+#define REVERT_USERHOST
+
+/* WALLCHOPS - A compatability shim for undernet users, /wallchops does
+ * the same thing as Hybrid's notice @#channel.  This is useful for scripts
+ * only
+ */
+#undef WALLCHOPS
+
+/* LOCAL_HACKOPS - Allow opers to hack ops in LOCAL channels (Only LOCAL
+ * channels, &channels).  This setting only affects the local server and
+ * does NOT allow global (#channels) to be hacked.
+ *
+ * This is done via /mode
+ *
+ */
+#undef LOCAL_HACKOPS
+
+/* OLD_KNOCK - KNOCK was changed since 6.3.1 release to have +p disable
+ * KNOCK'ing into the channel.  The old behaviour was to have +s disable
+ * KNOCK.  This setting reverts it to +p to be consistant with previous
+ * servers.
+ */
+#undef OLD_KNOCK
+
+/* SHOW_JUPE_MODE - Show the +j when a user or operator issues MODE #channel
+ * Idea from dilli
+ *
+ */
+#undef SHOW_JUPE_MODE
+
+/* End of +fr */
+
 /* HIDE_OPS
  * Define this to prevent non chanops from seeing what ops a channel has
  * NOT ADEQUATELY TESTED YET, DON'T USE ON PRODUCTION NETWORK --Rodder
@@ -191,13 +409,7 @@
  */
 #define  TS5_ONLY
 
-/* SLAVE_SERVERS - Use this to send LOCOPS and KLINES to servers you define
- * uses U: lines in ircd.conf, each server defined in an U: line
- * is sent a copy of the locally placed K-line, and will also
- * accept K-lines from those servers.
- * This is useful for sites with more than one client server.
- */
-#undef  SLAVE_SERVERS
+/* SLAVE_SERVERS was removed */
 
 /* FNAME_USERLOG and FNAME_OPERLOG - logs of local USERS and OPERS
  * Define this filename to maintain a list of persons who log
@@ -230,14 +442,7 @@
  */
 #define WARN_NO_NLINE
 
-/* CUSTOM_ERR - colorful notice/error/messages
- * Defining this will use custom notice/error/messages from
- * src/messages.tab instead of stock ones in src/messages_cust.tab
- * If you prefer the "colorful" messages that Hybrid was known for,
- * or if you wish to customize the  messages, define this.
- * Otherwise leave it undef'd for plain ole boring messages.
- */
-#undef  CUSTOM_ERR
+/* CUSTOM_ERR has been removed. */
 
 /* FAILED_OPER_NOTICE - send a notice to all opers when someone
  * tries to /oper and uses an incorrect password.
@@ -336,6 +541,13 @@
 #undef  O_LINES_OPER_ONLY
 #define P_LINES_OPER_ONLY
 #undef  U_LINES_OPER_ONLY
+#undef  C_LINES_OPER_ONLY
+
+/* STATS_QMARK_OPER_ONLY - Block /stats ? from non opers.  This is not
+ * recommended, as it makes it harder for opers to check on a link when
+ * they cannot connect to their oper server.
+ */
+#undef  STATS_QMARK_OPER_ONLY
 
 /* SPOOF_NOTICE - See a notice when a user connects with a
  * spoofed I: line
@@ -369,7 +581,7 @@
 #undef  WHOIS_NOTICE
 
 /* WHOIS_WAIT - minimum seconds between remote use of WHOIS before
- * max use count is reset
+ * max use count is reset.  0 will disable
  */
 #define WHOIS_WAIT 1
 
@@ -439,8 +651,9 @@
  * OPER_UMODES LOCOP_UMODES - set these to be the initial umodes when OPER'ing
  * These can be over-ridden in ircd.conf file, with flags in last O field
  */
-#define OPER_UMODES   (FLAGS_OPER|FLAGS_WALLOP|FLAGS_SERVNOTICE|FLAGS_OPERWALL)
-#define LOCOP_UMODES   (FLAGS_LOCOP|FLAGS_WALLOP|FLAGS_SERVNOTICE)
+#define OPER_UMODES   (FLAGS_OPER|FLAGS_WALLOP|FLAGS_SERVNOTICE|FLAGS_OPERWALL|\
+                       FLAGS_LOCOPS)
+#define LOCOP_UMODES   (FLAGS_LOCOP|FLAGS_WALLOP|FLAGS_SERVNOTICE|FLAGS_LOCOPS)
 
 /* MAXIMUM LINKS - max links for class 0 if no Y: line configured
  *
diff -uNrd ircd-hybrid-6.3.1.dist/include/config.h.dist ircd-hybrid-6.3.1/include/config.h.dist
--- ircd-hybrid-6.3.1.dist/include/config.h.dist	Sun Feb 17 00:58:09 2002
+++ ircd-hybrid-6.3.1/include/config.h.dist	Fri May  2 11:33:47 2003
@@ -111,6 +111,224 @@
 #define HPATH   "opers.txt"
 #define OPATH   "opers.motd"
 
+/* +fr patches - Hwy
+ * Each is optional...
+ */
+
+/* SAVE_MAXCLIENT - store the max local and global client connections
+ * into the file specified by MXPATH at the interval specified by
+ * SAVE_TIME
+ * Credits:  Hwy, idea from bahamut
+ */
+#define SAVE_MAXCLIENT
+#ifdef SAVE_MAXCLIENT
+# define MXPATH "ircd.max"
+# define SAVE_TIME 3600
+#endif
+
+/*
+ * XLINE_COMMAND - Enable a command to dynamically add an X: line
+ * Credits:  Hwy
+ */
+#undef XLINE_COMMAND
+
+/* Don't touch these */
+#define XLINE_WARN 0
+#define XLINE_REJECT 1
+#define XLINE_SILENT 2
+
+/* Set the default type of XLINE to be created, can be changed with
+ * /quote SET XLINETYPE [WARN|REJECT|SILENT].
+ */
+#define DEFAULT_XLINETYPE XLINE_WARN
+
+/*
+ * CRYPT_AUTH_PASSWORD - I: line passwords need to be crypted with
+ * mkpasswd to be valid
+ * Credits:  Hwy/larne
+ */
+#undef CRYPT_AUTH_PASSWORD
+
+/*
+ * GECOS_CLICONNECT - show the gecos when a user connects in the +c notice
+ *
+ * NOTE:  This MAY break oper scripts that parse the +c notice!
+ * Credits:  Hwy, backported from -7
+ */
+#define GECOS_CLICONNECT
+
+/* ANTI_IP_SPOOF - protects against TCP sequence guessing attacks
+ * Define this if you want the server to send a random ping at USER or NICK
+ * to defeat IP sequence spoofers. Note, this will stop _some_ very few
+ * clients from using the server. MIRC/IRCII clients are fine with this though
+ *
+ * IP sequence spoofing is obsolete...but for the time being...you can
+ * use this same code to defeat certain dumb drones and certain types of
+ * dumb bots.
+ *
+ * Credits:  JailBird, taken from FEFr5 with some fixes by Hwy
+ */
+#undef ANTI_IP_SPOOF
+
+/* REMOTE_WHOIS_NOTICE - Spy on users, even if they are remote */
+#undef REMOTE_WHOIS_NOTICE
+
+/* POST_REGISTER - Reject a client that issues the POST, GET, or PUT
+ * commands during registration.  This is often done by HTTP proxies.
+ * Credits:  Hwy, backported from -7
+ */
+#define POST_REGISTER
+
+/* CHECK_CLONE - Clonebot Protection.  This feature blocks connections if more
+ * than CHECK_CLONE_LIMIT clients connect from the same host to ANY server on
+ * the network within CHECK_CLONE_PERIOD seconds.  The feature is enabled
+ * CHECK_CLONE_DELAY seconds after the server is started.
+ *
+ * CHECK_CLONE_LIMIT and CHECK_CLONE_PERIOD are the defaults.  They can be
+ * changed with /quote SET.  CHECK_CLONE_DELAY is only used upon server
+ * boot, so it's not a SET'table option.
+ *
+ * Credits:  SeKs, ripped from FEFr5
+ */
+#define CHECK_CLONE
+#define CHECK_CLONE_LIMIT     5 /* recommended value 2   */
+#define CHECK_CLONE_PERIOD   30 /* recommended value 20  */
+#define CHECK_CLONE_DELAY    90 /* 90 secs should be ok */
+
+/* PART_MESSAGES - PART can include a comment, IRCnet and Dalnet style
+ * The message will get ignored by servers that do not understand...
+ * H6+tXi, H6+ins, H7, H6.3+fr all support this.
+ * Credits:  toot
+ */
+#define PART_MESSAGES
+
+/* SILENCE_ON_BAN - Banned users cannot speak in a channel, IRCnet style
+ * Credits:  toot
+ */
+#define SILENCE_ON_BAN
+
+/* TOPIC_UH - IRCnet style nick!user@host topic info.
+ * Credits:  toot, modified by Hwy
+ */
+#define TOPIC_UH
+
+/* FLAGS_COMMAND - Enable the csircd like FLAGS command
+ * Credits:  Hwy (backported from H7 contrib/m_flags.c)
+ */
+#define FLAGS_COMMAND
+
+/* FLAGS_ANNOUNCE - Announce the client's current and missing flags
+ * when they register, csircd like
+ */
+#define FLAGS_ANNOUNCE
+
+/* CLIENT_EXIT - Mark local client /quit's with "Quit: "
+ * Credits:  larne (stolen from +ins)
+ */
+#define CLIENT_EXIT
+
+/* STATS_IGNORED_NOTICE - Send a 419 numeric to a user who has a STATS
+ * request ignored
+ * Credits:  Idea by someone from the EFnet.org forum, code by Hwy
+ */
+#define STATS_IGNORED_NOTICE
+
+/* WHOIS_TRYAGAIN - When a remote WHOIS request is ignored, send a "Load
+ * too high" numeric to let them know it was ignored.  Stock Hybrid will
+ * not send this notice, just silently ignore it.  Sending a notice CAN
+ * increase sendQ.
+ */
+#define WHOIS_TRYAGAIN
+
+/* NEG_PORT - Allow a negative port number to be used in a C: line to
+ * specify a port number, but disable autoconnect on that C: line
+ * Idea from jv's +hemp patch for IRCnet
+ *
+ * Enabling this option will also hide the "autoconnect is disabled" warnings
+ * that will normally be sent every connection frequency minutes
+ */
+#define NEG_PORT
+
+/* DEFAULT_MAXTKTIME - Use this to set the default maximum TKLINE time
+ * in minutes.  This option can be changed at runtime using /quote SET
+ * MAXTKTIME minutes
+ */
+#define DEFAULT_MAXTKTIME (60*24)
+
+/* DEOPER_NOTICE - Use this to see when opers remove their operator status
+ * or quit.  - Spying... Hwy
+ */
+#undef DEOPER_NOTICE
+
+/* JUPE_BYPASS - Use this to allow opers to join and speak in juped (+j)
+ * channels, useful for under attack channels, drone channels, and oper
+ * channels
+ */
+#define JUPE_BYPASS
+
+/* TKLINE_EXPIRE_NOTICE - Use this to enable or disable the stock Hybrid
+ * temporary kline expiration notice
+ */
+#define TKLINE_EXPIRE_NOTICE
+
+/* TDLINE_EXPIRE_NOTICE - Use this to enable or disable fl_'s temporary
+ * dline expiration notice
+ */
+#define TDLINE_EXPIRE_NOTICE
+
+/* PROPAGATE_AWAY - Propogate AWAY messages to (and from) other servers.
+ * This allows users to see you marked as AWAY on distant servers, without
+ * resorting to using remote WHOIS.  This is standard in Hybrid 7 and will
+ * be standard in the next csircd version, so it should be available to
+ * Hybrid 6 users as well.
+ */
+#define PROPAGATE_AWAY
+
+/* BURST_AWAY - If AWAY messages are propagated, then burst them to a
+ * connecting server as well.  Hybrid 7 does NOT do this.
+ *
+ * NOTE:  This will increase your burst size.
+ */
+#define BURST_AWAY
+
+/* REVERT_USERHOST - Revert USERHOST to the original behavior, making
+ * USERHOST on yourself return the hostname (even if it is spoofed) rather
+ * than your real IP.  This will break mIRC's SERVER method of finding your
+ * IP when a user runs behind a NAT, but will fix the possible problems
+ * with client's userlists (adding protection for yourself)
+ */
+#define REVERT_USERHOST
+
+/* WALLCHOPS - A compatability shim for undernet users, /wallchops does
+ * the same thing as Hybrid's notice @#channel.  This is useful for scripts
+ * only
+ */
+#undef WALLCHOPS
+
+/* LOCAL_HACKOPS - Allow opers to hack ops in LOCAL channels (Only LOCAL
+ * channels, &channels).  This setting only affects the local server and
+ * does NOT allow global (#channels) to be hacked.
+ *
+ * This is done via /mode
+ *
+ */
+#undef LOCAL_HACKOPS
+
+/* OLD_KNOCK - KNOCK was changed since 6.3.1 release to have +p disable
+ * KNOCK'ing into the channel.  The old behaviour was to have +s disable
+ * KNOCK.  This setting reverts it to +p to be consistant with previous
+ * servers.
+ */
+#undef OLD_KNOCK
+
+/* SHOW_JUPE_MODE - Show the +j when a user or operator issues MODE #channel
+ * Idea from dilli
+ *
+ */
+#undef SHOW_JUPE_MODE
+
+/* End of +fr */
+
 /* HIDE_OPS
  * Define this to prevent non chanops from seeing what ops a channel has
  * NOT ADEQUATELY TESTED YET, DON'T USE ON PRODUCTION NETWORK --Rodder
@@ -191,13 +409,7 @@
  */
 #define  TS5_ONLY
 
-/* SLAVE_SERVERS - Use this to send LOCOPS and KLINES to servers you define
- * uses U: lines in ircd.conf, each server defined in an U: line
- * is sent a copy of the locally placed K-line, and will also
- * accept K-lines from those servers.
- * This is useful for sites with more than one client server.
- */
-#undef  SLAVE_SERVERS
+/* SLAVE_SERVERS was removed */
 
 /* FNAME_USERLOG and FNAME_OPERLOG - logs of local USERS and OPERS
  * Define this filename to maintain a list of persons who log
@@ -230,14 +442,7 @@
  */
 #define WARN_NO_NLINE
 
-/* CUSTOM_ERR - colorful notice/error/messages
- * Defining this will use custom notice/error/messages from
- * src/messages.tab instead of stock ones in src/messages_cust.tab
- * If you prefer the "colorful" messages that Hybrid was known for,
- * or if you wish to customize the  messages, define this.
- * Otherwise leave it undef'd for plain ole boring messages.
- */
-#undef  CUSTOM_ERR
+/* CUSTOM_ERR has been removed. */
 
 /* FAILED_OPER_NOTICE - send a notice to all opers when someone
  * tries to /oper and uses an incorrect password.
@@ -336,6 +541,13 @@
 #undef  O_LINES_OPER_ONLY
 #define P_LINES_OPER_ONLY
 #undef  U_LINES_OPER_ONLY
+#undef  C_LINES_OPER_ONLY
+
+/* STATS_QMARK_OPER_ONLY - Block /stats ? from non opers.  This is not
+ * recommended, as it makes it harder for opers to check on a link when
+ * they cannot connect to their oper server.
+ */
+#undef  STATS_QMARK_OPER_ONLY
 
 /* SPOOF_NOTICE - See a notice when a user connects with a
  * spoofed I: line
@@ -369,7 +581,7 @@
 #undef  WHOIS_NOTICE
 
 /* WHOIS_WAIT - minimum seconds between remote use of WHOIS before
- * max use count is reset
+ * max use count is reset.  0 will disable
  */
 #define WHOIS_WAIT 1
 
@@ -439,8 +651,9 @@
  * OPER_UMODES LOCOP_UMODES - set these to be the initial umodes when OPER'ing
  * These can be over-ridden in ircd.conf file, with flags in last O field
  */
-#define OPER_UMODES   (FLAGS_OPER|FLAGS_WALLOP|FLAGS_SERVNOTICE|FLAGS_OPERWALL)
-#define LOCOP_UMODES   (FLAGS_LOCOP|FLAGS_WALLOP|FLAGS_SERVNOTICE)
+#define OPER_UMODES   (FLAGS_OPER|FLAGS_WALLOP|FLAGS_SERVNOTICE|FLAGS_OPERWALL|\
+                       FLAGS_LOCOPS)
+#define LOCOP_UMODES   (FLAGS_LOCOP|FLAGS_WALLOP|FLAGS_SERVNOTICE|FLAGS_LOCOPS)
 
 /* MAXIMUM LINKS - max links for class 0 if no Y: line configured
  *
diff -uNrd ircd-hybrid-6.3.1.dist/include/ircd.h ircd-hybrid-6.3.1/include/ircd.h
--- ircd-hybrid-6.3.1.dist/include/ircd.h	Thu Dec 13 18:16:34 2001
+++ ircd-hybrid-6.3.1/include/ircd.h	Sat Apr 19 21:06:44 2003
@@ -41,6 +41,8 @@
   int noisy_htm;        /* noisy htm or not ? */
   int lifesux;
 
+  int maxtktime;        /* maximum TKLINE time */
+
 #ifdef IDLE_CHECK
   int idletime;
 #endif
@@ -66,6 +68,15 @@
   int spam_num;
   int spam_time;
 #endif
+
+#ifdef CHECK_CLONE
+  int clone_num;
+  int clone_period;
+#endif
+
+#ifdef XLINE_COMMAND
+  int xlinetype;
+#endif
 };
 
 struct Counter {
@@ -108,6 +119,7 @@
 #define SPLITNUM   GlobalSetOptions.split_smallnet_size
 #define SPLITUSERS GlobalSetOptions.split_smallnet_users
 
+#define MAXTKTIME  GlobalSetOptions.maxtktime
 
 extern char*          debugmode;
 extern int            debuglevel;
@@ -123,6 +135,7 @@
 extern int            cold_start;
 extern int            dline_in_progress;
 extern int            dorehash;
+extern int            doremotd;
 extern int            rehashed;
 extern float          currlife;
 extern struct Client  me;
@@ -151,4 +164,9 @@
  * complain
  */
 #define MAX_SETBACK_TIME 1800
+
+#ifdef SAVE_MAXCLIENT
+extern void write_stats(void);
+#endif
+
 #endif
diff -uNrd ircd-hybrid-6.3.1.dist/include/m_commands.h ircd-hybrid-6.3.1/include/m_commands.h
--- ircd-hybrid-6.3.1.dist/include/m_commands.h	Thu Nov 29 01:28:23 2001
+++ ircd-hybrid-6.3.1/include/m_commands.h	Mon Apr 21 20:44:43 2003
@@ -34,6 +34,9 @@
 extern int m_unkline(struct Client *,struct Client *,int,char **);
 extern int m_dline(struct Client *,struct Client *,int,char **);
 extern int m_undline(struct Client *,struct Client *,int,char **);
+#ifdef XLINE_COMMAND
+extern int m_xline(struct Client *,struct Client *,int,char **);
+#endif
 
 extern int m_gline(struct Client *,struct Client *,int,char **);
 extern int m_ungline(struct Client *,struct Client *,int,char **);
@@ -99,4 +102,21 @@
 extern int m_dns(struct Client *,struct Client *,int,char **);
 extern int m_htm(struct Client *,struct Client *,int,char **);
 extern int m_set(struct Client *,struct Client *,int,char **);
+
+#ifdef POST_REGISTER
+extern int m_webproxy(struct Client *,struct Client *,int,char **);
+#endif
+
+#ifdef FLAGS_COMMAND
+extern int m_flags(struct Client *, struct Client *, int, char **);
+#endif
+
+extern int m_map(struct Client *,struct Client *,int,char **);
+extern int m_etrace(struct Client *,struct Client *,int,char **);
+extern int m_encap(struct Client *,struct Client *,int,char **);
+
+#ifdef WALLCHOPS
+extern int m_wallchops(struct Client *,struct Client *,int,char **);
+#endif
+
 #endif /* INCLUDED_m_commands_h */
diff -uNrd ircd-hybrid-6.3.1.dist/include/m_flags.h ircd-hybrid-6.3.1/include/m_flags.h
--- ircd-hybrid-6.3.1.dist/include/m_flags.h	Wed Dec 31 19:00:00 1969
+++ ircd-hybrid-6.3.1/include/m_flags.h	Sat Apr 26 19:36:56 2003
@@ -0,0 +1,43 @@
+/*
+ *  m_flags.h: Implements comstud-style mode flags.
+ *
+ *  Copyright 2002 by W. Campbell and the ircd-hybrid development team
+ *
+ *  Redistribution and use in source and binary forms, with or without
+ *  modification, are permitted provided that the following conditions are
+ *  met:
+ *
+ *  1.Redistributions of source code must retain the above copyright notice,
+ *    this list of conditions and the following disclaimer.
+ *  2.Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *  3.The name of the author may not be used to endorse or promote products
+ *    derived from this software without specific prior written permission.
+ *
+ *  THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ *  IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+ *  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+ *  DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
+ *  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+ *  (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
+ *  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ *  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
+ *  STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
+ *  IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ *  POSSIBILITY OF SUCH DAMAGE.
+ *
+ *  $Id: m_flags.c,v 1.12 2002/11/21 20:16:30 leeh Exp $
+ */
+
+#include "config.h"
+
+#ifndef FLAGS_H
+#define FLAGS_H
+
+#ifdef FLAGS_COMMAND
+char *set_flags_to_string(struct Client *client_p);
+char *unset_flags_to_string(struct Client *client_p);
+#endif
+
+#endif
